#! @SHELL@

# Copyright (c) 2013
# Pierre-Jean Fichet. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or
# without modification, are permitted provided that the following
# conditions are met:
# 
#   1.  Redistributions of source code must retain the above
#     copyright notice, this list of conditions and the following
#     disclaimer.
#   2.  Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials
#     provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS
# IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# $Id: U.sh,v 0.1 2013/11/14 12:09:13 pj Exp pj $


# u: set Utroff environment
# usage:
#
# u troff -mus f.tr | u dpost | ps2pdf - > f.pdf
# . u # start a session
# troff -mus f.tr | dpost | ps2pdf - > f.pdf
# . u # stop the session

UPATH=@BINDIR@/:$PATH
UMANPATH=@MANDIR@/:$MANPATH
UTROFFONTS=@LIBDIR@/font/,@OTFDIR@/
UTROFFMACS=@MACDIR@/

# Set the Utroff environment
setuenv(){
	export OLDPATH="$PATH"
	export OLDMANPATH="$MANPATH"
	export OLDTROFFONTS="$TROFFFONTS"
	export OLDTROFFMACS="$TROFFMACS"
	export OLDPS1="$PS1"
	export PATH="$UPATH"
	export MANPATH="$UMANPATH"
	export TROFFONTS="$UTROFFONTS"
	export TROFFMACS="$UTROFFMACS"
	export PS1="$PS1\033[01;mU>\033[0m "
}

# Unset the utroff environment
unsetuenv(){
	export PATH="$OLDPATH"
	export MANPATH="$OLDMANPATH"
	export TROFFMACS="$OLDTROFFMACS"
	export TROFFONTS="$OLDTROFFONTS"
	export PS1="$OLDPS1"
	unset OLDPATH OLDMANPATH OLDTROFFONTS OLDTROFFMACS
}


if [ $# == 0 ]
then 
	# No args, session mode
	if [ "$OLDPATH" == "" ]
	then
		setuenv
	else
		unsetuenv
	fi
else
	# Args, command mode
	setuenv
	exec $@
	unsetuenv
fi
